#include <bits/stdc++.h>

using namespace std;

int main()
{
    ios::sync_with_stdio(false) ;
    cin.tie(0) ;
    cout.tie(0) ;
    int n , m ;
    cin >> n >> m ;
    long long mat[n+1][m+1] ;
    for(int i=1 ; i<=n ; i++){
        for(int j=1 ; j<=m ; j++){
            cin >> mat[i][j] ;
        }
    }
    int q ;
    cin >> q ;
    int a , b ;
    for(int k=0 ; k<q ; k++){
        cin >> a >> b ;
        long long c ;
        c=mat[a][b] ;
        mat[a][b]=10000000000000000 ;
        long long res[n+1][m+1] ;
        res[1][1]=mat[1][1] ;
        for(int i=2 ; i<=n ; i++){
            res[1][i]=mat[1][i]+res[1][i-1] ;
        }
        for(int i=2 ; i<=m ; i++){
            res[i][1]=mat[i][1]+res[i-1][1] ;
        }
        for(int i=2 ; i<=n ; i++){
            for(int j=2 ; j<=m ; j++){
                if(res[i][j-1]<res[i-1][j]){
                    res[i][j]=mat[i][j]+res[i][j-1] ;
                }
                else{
                    res[i][j]=mat[i][j]+res[i-1][j] ;
                }
            }
        }
        cout << res[n][m] << endl ;
        mat[a][b]=c ;

    }
    return 0;
}